﻿@using System.Web.UI.WebControls
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}
@model Toyota.Common.Web.MVC.ModelHolder

<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>

@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        @*font-weight: bold;*@
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px; border:1px solid #6A8CCB;}
}

<style type="text/css">
    #gridLP_I, #gridLP, #gridLPAdd_I, #gridLPAdd, #sePrice_I, #sePrice,#gridRouteAdd_I,#gridRouteAdd,#deValidFrom_I,#deValidFrom
    {
        background-color:#F6CECE!important;    
    }
    
    #gridRoute_I, #gridRoute,#ValidFrom_I,#ValidFrom,#ValidTo_I, #ValidTo
    {
        background-color:#F5F6CE!important;    
    }


</style>

<script type="text/javascript">
    var linkStatusObj = '';
    var linkNameObj = '';
    var _status = ''; //For saving data
    var statusButton = "S"; //For retrieve data when callback
    var GlobalSelectedKey = null; //For get selected row
    var isSelect = false; //For get selected row

    $(document).ready(function(){
        gridLP.SetHeight(-73);
        gridRoute.SetText('');
        gridLP.SetText('');
        ValidFrom.SetText('');
        GridgridRoute.UnselectRows();
        GridgridLP.UnselectRows();
        gridRouteAdd.SetValue('');
        gridLPAdd.SetValue('');
        sePrice.SetText('');
        deValidFrom.SetText('');
        GridgridRouteAdd.UnselectRows();
        GridgridLPAdd.UnselectRows();
        //Edit.SetEnabled(false);
        //Delete.SetEnabled(false);

    });

     function fungsi(s, e) { }

    
function GetProductionMonth(productionMonth) {
         var paramStr = String(productionMonth).replace('-', '');
         var paramStrLength = String(paramStr).length;

         var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
         var month = String(paramStr).substring(0, paramStrLength - 5);
         var monthEnum = {
             January: '01',
             February: '02',
             March: '03',
             April: '04',
             May: '05',
             June: '06',
             July: '07',
             August: '08',
             September: '09',
             October: '10',
             November: '11',
             December: '12'
         };
         var monthNum = "";
         if (Boolean(month))
             monthNum = monthEnum[month];
          
         return "01." + monthNum + "." + year;
 }

    function btnSearch(s, e) {
     if (gridLP.GetValue() == null)
        {
           $.msgBox({ title: "Information", type: "info", content: "Please input mandatory selection criteria"});
        }
     else
        {
           GridRoutePrice.ClearFilter();
        }
    }

    function btnClear(s, e) {
        gridRoute.SetValue('');
        gridLP.SetValue('');
        GridgridRoute.UnselectRows();
        GridgridLP.UnselectRows();
        ValidFrom.SetText('');
        ValidTo.SetText('');
        GridRoutePrice.ClearFilter();
//        Edit.SetEnabled(false);
//        Delete.SetEnabled(false);
        btnNew.SetEnabled(true);
    }

    function BeginGridCallback(s, e) {
       e.customArgs["RouteCd"] = gridRoute.GetValue();
       e.customArgs["LPCd"] = gridLP.GetValue();
       e.customArgs["ValidFrom"] = ValidFrom.GetText();
       e.customArgs["ValidTo"] = ValidTo.GetText();

    }

   function btnCancel_click(s, e) {
        gridRouteAdd.SetValue('');
        gridLPAdd.SetValue('');
        sePrice.SetText('');
        deValidFrom.SetText('');
        GridgridRouteAdd.UnselectRows();
        GridgridLPAdd.UnselectRows();
        GridRoutePrice.UnselectAllRowsOnPage();
        SaveEdit2.SetVisible(false);
        SaveEdit.SetVisible(true);
        SaveEdit.SetEnabled(false);
        Cancel.SetEnabled(false);
        Edit.SetEnabled(true);
//        Delete.SetEnabled(true);
        Search.SetEnabled(true);
        Clear.SetEnabled(true);
        btnNew.SetEnabled(true);
        isSelect = true;
        GridRoutePrice.CancelEdit();        
    }

    function btnNew_click(s, e) {
        gridRouteAdd.SetValue('');
        gridLPAdd.SetValue('');
        sePrice.SetText('');
        deValidFrom.SetText('');
        
        statusButton = "S"; 
        _status = "New";
        
        GlobalSelectedKey = GridRoutePrice.GetSelectedKeysOnPage(); 
        SaveEdit.SetEnabled(true);
        Cancel.SetEnabled(true);
        btnNew.SetEnabled(false);
        Edit.SetEnabled(false);
//        Delete.SetEnabled(false);
        Search.SetEnabled(false);
        Clear.SetEnabled(false);  
        GridRoutePrice.AddNewRow();
    }


    function RoutePrice_SelectionChanged(s, e) {
         var selectedRowCount = s.GetSelectedRowCount();
        if (selectedRowCount > 0) {
            Edit.SetEnabled(true);
//            Delete.SetEnabled(true);
        } 
        else
        {
           //Edit.SetEnabled(false);
           //Delete.SetEnabled(false);
        }
    }

    
    function btnSave_click(s, e) {
        var _RouteCd = gridRouteAdd.GetText();
        var _LPCd = gridLPAdd.GetText();
        var _Price = sePrice.GetText();
        var _Valid_From = deValidFrom.GetText();
      
        if (_RouteCd == '' || _LPCd == '' || _Price == '' || _Valid_From == '')
        {
            $.msgBox({ title: "Information", type: "info", content: "Please fill all field"});
        }
        else if (_Price == 0){
            $.msgBox({ title: "Information", type: "info", content: "Please insert price not zero (0)"});
        }
        else
        {
                $.msgBox({
                           type: "confirm",
                           content: "Are you sure want to save?",
                           buttons: [{ value: "Yes" }, { value: "No"}],
                           success: function (result) {
                                if (result == "Yes") { Action_SAVE(_LPCd,_Price,_RouteCd,GetProductionMonth(deValidFrom.GetText())); }
                            }
                        });
            } 
    }


    function Action_SAVE(LP_CD,PRICE,ROUTE,DATE){
            $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/RoutePrice/InsertRoutePrice")",
                data:
                {
                    RouteCd: ROUTE,
                    LPCd: LP_CD,
                    Price: PRICE,
                    Valid_From: DATE
                   },
                success: function (ResultQuery) {
                    if(ResultQuery == 1) 
                    {
                        vRouteCd = ROUTE;
                        vLpCd = LP_CD;
                        vValidFrom = "";
                         $.msgBox({ title: "Information", type: "info", content: "Success to save data"}); 
                        btnCancel_click();                  
                    }
                    else if (ResultQuery == 0) 
                    {
                        $.msgBox({ title: "Warning", content: "Date already exist. Please input another values"});
                    }
                    else if (ResultQuery == 2) 
                    {
                        $.msgBox({ title: "Warning", content: "Valid from date cannot less than last valid from"});
                    }
                    else if (ResultQuery == 3) 
                    {
                        $.msgBox({ title: "Error", type: "error",content: "You are not authorized to perform this action."});    
                    }
                    
                     else if (ResultQuery == 4) 
                    {
                        $.msgBox({ title: "Error", type: "error",content: "Route price has been released for selected period."});    
                    }
                     else if (ResultQuery == 5) 
                    {
                        $.msgBox({ title: "Error", type: "error",content: "Valid from cannot less then current month"});    
                    }
                    else if (ResultQuery == 6) 
                    {
                        $.msgBox({ title: "Error", type: "error",content: "Period month not valid"});    
                    }
                    else
                    {
                        //alert (ResultQuery);
                    }
                },
                error: function (ResultQuery) {
                $.msgBox({ title: "Error", content: "Error"});
                }
            }); 
    
    
    }

    
    function DeleteData(s, e) {
        var selectedKey = GridRoutePrice.GetSelectedKeysOnPage();
       
        if(selectedKey.length < 1) {
             $.msgBox({ title: "Warning", content: "Please select at least one record"});
            GridRoutePrice.UnselectAllRowsOnPage();
            return;
        }

//        if(selectedKey.length > 1) {
//            $.msgBox({ title: "Error", type: "error", content: "Only one data can be deleted in one time"});
//            GridRoutePrice.UnselectAllRowsOnPage();
//            return;
//        }
        else
        functionDelete();
     }

    function functionDelete(){
    $.msgBox({
                       type: "confirm",
                       content: "Are you sure want to delete?",
                       buttons: [{ value: "Yes" }, { value: "No"}],
                       success: function (result) {
                            if (result == "Yes") { 
                                              //DELETE
                                            var GridId = "";
                                            var rowpage=GridRoutePrice.GetPageIndex() * GridRoutePrice.cpPageSize;
                                            for (var Index = GridRoutePrice.GetTopVisibleIndex(); Index < ((rowpage) + GridRoutePrice.GetVisibleRowsOnPage());
                                                Index++) {
                                                if (GridRoutePrice.IsRowSelectedOnPage(Index)) {
                                                    GridId += 
                                                        GridRoutePrice.cproutecd[Index - (rowpage)] + "_" +
                                                        GridRoutePrice.cplpcd[Index - (rowpage)] + "_" +
                                                        GridRoutePrice.cpvalidfrom[Index - (rowpage)] + "_" +
                                                        GridRoutePrice.cpvalidto[Index - (rowpage)] + ";";
                                                }
                                            }

                                            if (GridId == "") {
                                                $.msgBox({ title: "Information", type: "info", content: "No Data Selected !"});
                                            }
                                            else {
                                                  $.ajax({
                                                    type: "POST",
                                                    url: "@Url.Content("~/RoutePrice/Delete")",
                                                    data: {
                                                        GridId: GridId
                                                        },
                                                        success: function (ResultQuery) {
                                                        if (ResultQuery == "1")
                                                        {
                                                             $.msgBox({ title: "Information", type: "info", content: "Success to delete data"});
                                                             GridRoutePrice.PerformCallback();
                                                             GridRoutePrice.CancelEdit();
                                                             GridRoutePrice.UnselectAllRowsOnPage();
                                                             btnCancel_click();
                   
                                                        }
                                                        else if (ResultQuery == "2")
                                                        {
                                                             $.msgBox({ title: "Error", content: "Data can not be deleted."});
                                                        }
                                                        else if (ResultQuery == 3) 
                                                        {
                                                            $.msgBox({ title: "Error", type: "error",content: "You are not authorized to perform this action."});    
                                                        }
                                                        else
                                                        {
                                                            alert (ResultQuery);
                                                        }
                                                    },
                                                    error: function (ResultQuery) {
                                                    $.msgBox({ title: "Warning", content: "Error when delete data"});
                                                    }
                                                    });
                                                }
                            
                             }
                        }
                    });

    }
   
    function btnDelete(s, e) {
        DeleteData();
    }



    function OnEndCallback(s, e) {
    if(GlobalSelectedKey != null && isSelect == true){
            isSelect = false;
            GridRoutePrice.SelectRowsByKey(GlobalSelectedKey);
            GlobalSelectedKey = null;
            }
    if(statusButton == 'E'){
        }
        else
        {
            if (linkNameObj !='') {
                if (linkStatusObj == '')
                    document.getElementById(linkNameObj).style.display = "block";
                else
                    document.getElementById(linkNameObj).style.display = "none";
                }
        }
    }



function btnEdit(s, e) {
        var selectedKey = GridRoutePrice.GetSelectedKeysOnPage();

       
        if(selectedKey.length < 1) {
            $.msgBox({ title: "Warning", content: "Please select at least one record"});
            GridRoutePrice.UnselectAllRowsOnPage();
            return;
        }

        if(selectedKey.length > 1) {
            $.msgBox({ title: "Error", type: "error", content: "Only one data can be edited in one time"});
            GridRoutePrice.UnselectAllRowsOnPage();
            return;
        }

        if(selectedKey.length == 1) {
            
        var aKey = selectedKey[0].toString().split("|");
        var currentdate = new Date();
        var curMonth='';
        if((currentdate.getMonth()+1) <10){
            curMonth="0"+(currentdate.getMonth()+1);
        }
        var currentdate1 = currentdate.getFullYear()+""+curMonth+""+currentdate.getDate();

        var validTo = aKey[3];
        var validTo1 = validTo.toString().split("-");
        var validTo2 = validTo1[0]+""+validTo1[1]+""+validTo1[2];

            //if(aKey[3] == "9999-12-31")
            if(validTo2 > currentdate1)
            {
                GridRoutePrice.StartEditRowByKey(selectedKey);
                //SaveEdit.SetEnabled(true);
                SaveEdit2.SetVisible(true);
                Cancel.SetEnabled(true);
                //popnew.SetEnabled(false);
                //Edit.SetEnabled(false);
                //Delete.SetEnabled(false);
                Search.SetEnabled(false);
                Clear.SetEnabled(false);
                SaveEdit2.SetVisible(true);
                SaveEdit.SetVisible(false);
            }
            else
            {
                $.msgBox({ title: "Warning", content: "Data Can not edit, data valid to less than current date"});
                //btnCancel_click();
                
            }
        }


//        Cancel.SetEnabled(true);
//        btnNew.SetEnabled(false);

     }
    

function btnSaveEdit(s, e) {
        var _txtEditLPCode = txtEditLPCode.GetText();
        var _txtEditLPRoute = txtEditLPRoute.GetText();
        var _Price2 = sePrice.GetValue();
        var _Valid_From2 = GetProductionMonth(deValidFrom.GetValue());
        var _valid_To2 = deValidTo.GetText();


        if (_Price2 == 0){
            $.msgBox({ title: "Information", type: "info", content: "Please insert price not zero (0)"});
        }else{


        $.msgBox({
                       type: "confirm",
                       content: "Are you sure want to save change?",
                       buttons: [{ value: "Yes" }, { value: "No"}],
                       success: function (result) {
                            if (result == "Yes") { Action_EDIT(_txtEditLPCode,_Price2,_txtEditLPRoute,_Valid_From2,_valid_To2); }
                        }
                    });       
         } 
        
    }

function Action_EDIT(LP_CD,PRICE,ROUTE,DATE_FROM,DATE_TO){

            $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/RoutePrice/UpdateRoutePrice")",
                data:
                {
                    RouteCd2: ROUTE,
                    LPCd2: LP_CD,
                    Price2: PRICE,
                    Valid_From2: DATE_FROM,
                    Valid_To2: DATE_TO
                   },
                success: function (ResultQuery) {
                    if(ResultQuery == 1) 
                    {
                             $.msgBox({ title: "Information", type: "info", content: "Success to save data" });
                             GridRoutePrice.PerformCallback();  
                             btnCancel_click();
                             GridRoutePrice.UnselectAllRowsOnPage();
                             vRouteCd = ROUTE;
                             vLpCd = LP_CD;
                             vValidFrom = "";              
                    }
                    else if (ResultQuery == 2) 
                    {
                         $.msgBox({ title: "Warning", content: "Data can not edit"});
                         GridRoutePrice.PerformCallback();  
                         btnCancel_click();
                         GridRoutePrice.UnselectAllRowsOnPage();
                         vRouteCd = ROUTE;
                         vLpCd = LP_CD;
                         vValidFrom = "";  
                    }
                    else if (ResultQuery == 3) 
                    {
                        $.msgBox({ title: "Warning", content: "Valid from date cannot less than last valid from"});
                    }
                    else if (ResultQuery == 4) 
                    {
                        $.msgBox({ title: "Error", type: "error",content: "You are not authorized to perform this action."});    
                    }
                    else
                    {
                        //alert (ResultQuery);
                    }
                },
                error: function (ResultQuery) {
                $.msgBox({ title: "Error", content: "Error"});
                }
            }); 
    
    
    }




</script>

<div>
    @Html.Partial("RoutePriceHeader")
</div>
<div style="height: 3px;">
</div>
<div>
    @Html.Action("GridRoutePriceData", "RoutePrice")
</div>

@Html.DevExpress().PopupControl(settings =>
    {
        settings.Name = "popupNewRoutePrice";
        settings.Width = System.Web.UI.WebControls.Unit.Percentage(23);
        settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
        settings.Modal = true;
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        //settings.DragElement = DragElement.Window;
        //settings.ShowHeader = false;
        settings.SetContent(() =>
        {
            Html.RenderPartial("PopupAdd");
        });
    }).GetHtml()
